#include <stdio.h>
#include <assert.h>
#include <queue>
#include <climits>
#include <iostream>
#include <functional>

using namespace std;

#define MAXN 1000000

struct Pair {
    int h;
    int idx;
    
    Pair(int h_ = -1, int idx_ = -1) : h(h_), idx(idx_) {}
    bool operator<(const Pair& right) const { return h < right.h; }
};

int posiziona(int N, int L, int H[]) {
    priority_queue<Pair> s;     // let's use a heap to access highest elements
    for(int i = 0; i < L-1; i++) s.push(Pair(H[i], i));     // init

    int res = INT_MAX;
    for(int i = L-1; i < N; i++) {
        s.push(Pair(H[i], i));     // add one more element

        // compute cost (max - 2nd_max)/2
        while(s.top().idx <= i-L) s.pop();    // remove old elements
        Pair max = s.top();
        s.pop();                 // temporarily remove the max element
        while(s.top().idx <= i-L) s.pop();    // remove old elements
        int cost = (max.h - s.top().h) / 2;

        res = min(res, cost);    // possibly, update the minimum
        s.push(max);             // put back the max element
    }
    
    return res;
}


int H[MAXN];

int main() {
    FILE *fr, *fw;
    int N, L, i;

#ifdef EVAL
    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
#else
    fr = stdin;
    fw = stdout;
#endif
    assert(2 == fscanf(fr, "%d %d", &N, &L));
    for(i=0; i<N; i++)
        assert(1 == fscanf(fr, "%d", &H[i]));

    fprintf(fw, "%d\n", posiziona(N, L, H));
    fclose(fr);
    fclose(fw);
    return 0;
}
