#include <stdio.h>
#include <assert.h>
#include <deque>
#include <map>

#define MAXN 100000

using namespace std;

map<int,int> supply; // map of available cards by price
deque<int> deck;     // ordered deck of cards

int C[MAXN], A[MAXN], P[MAXN], R[MAXN], V[MAXN];

int main() {
    FILE *fr, *fw;
    int N, M, T, i;

#ifdef EVAL
    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
#else
    fr = stdin;
    fw = stdout;
#endif
    assert(3 == fscanf(fr, "%d %d %d", &N, &M, &T));
    for(i=0; i<M; i++)
        assert(1 == fscanf(fr, "%d", &C[i]));
    for(i=0; i<N; i++)
        assert(4 == fscanf(fr, "%d %d %d %d", &A[i], &P[i], &R[i], &V[i]));

    for (int i=0; i<M; ++i) deck.push_back(C[i]);
    for (int i=0; i<N; ++i) if (A[i]) supply[P[i]] = i;
    for (int i=0; i<T; ++i) {
        // compute which card to buy
        int r = 0;
        for (int i=0; i<5; ++i) r += R[deck[i]];
        auto it = --supply.upper_bound(r);
        // buy the card
        deck.push_back(it->second);
        A[it->second]--;
        if (A[it->second] == 0) supply.erase(it);
        // discard the hand
        for (int i=0; i<5; ++i) deck.push_back(deck[i]);
        for (int i=0; i<5; ++i) deck.pop_front();
    }
    int v = 0;
    for (int c : deck) v += V[c];
    
    fprintf(fw, "%d\n", v);
    fclose(fr);
    fclose(fw);
    return 0;
}
